//+------------------------------------------------------------------+
//|                                                MA_In_Color.mq4   |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| Modified from LSMA_In_Color to use any MA by Robert Hill         |
//|           AlexHacker007@yandex.ru                        |     
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, FX Sniper and Robert Hill"
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 RoyalBlue
#property indicator_color3 Red
//----

extern int       MAPeriod=14;
extern int       MAType=4;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//---- variables
int    MAMode;
string strMAType;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);

   switch(MAType)
     {
      case 1: strMAType="EMA"; MAMode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MAMode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MAMode=MODE_LWMA; break;
      case 4: strMAType="LSMA"; break;
      default: strMAType="SMA"; MAMode=MODE_SMA; break;
     }
   IndicatorShortName( strMAType+ " (" +FindPeriod(Period()) + ") ");
   ObjectDelete("AlexHacker009");
   ObjectDelete("AlexHacker008");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LSMA(int Rperiod, int shift)
  {
   int i;
   double sum;
   int length;
   double lengthvar;
   double tmp;
   double wt;
//----
   length=Rperiod;
//----
   sum=0;
   for(i=length; i>=1 ;i--)
     {
      lengthvar=length + 1;
      lengthvar/=3;
      tmp=0;
      tmp =(i - lengthvar)*Close[length-i+shift];
      sum+=tmp;
     }
   wt=sum*6/(length*(length+1));
//----
   return(wt);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double MA_Cur, MA_Prev;
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit=Bars - counted_bars;
//----

int zzz, zzz1;
      if (Period()==1) zzz=144;
      if (Period()==5) zzz=89;
      if (Period()==15) zzz=110;
      if (Period()==30) zzz=55;
      if (Period()==60) zzz=21;
      if (Period()==240) zzz=13;
      if (Period()==1440) zzz=8;
      
      ObjectDelete("DEV");
      ObjectCreate("DEV", OBJ_STDDEVCHANNEL, 0, Time[zzz], 0, Time[0], 0);
      ObjectSet ("DEV", OBJPROP_DEVIATION, 1);
      ObjectSet ("DEV", OBJPROP_COLOR, RoyalBlue);
      ObjectSet ("DEV", OBJPROP_WIDTH, 2);
       
       if (Period()==1) zzz1=72;
      if (Period()==5) zzz1=21;
      if (Period()==15) zzz1=55;
      if (Period()==30) zzz1=55;
      if (Period()==60) zzz1=21;
      if (Period()==240) zzz1=13;
      if (Period()==1440) zzz1=8;     
      ObjectDelete("DEV1");
      ObjectCreate("DEV1", OBJ_STDDEVCHANNEL, 0, Time[zzz1], 0, Time[0], 0);
      ObjectSet ("DEV1", OBJPROP_DEVIATION, 1);
      ObjectSet ("DEV1", OBJPROP_COLOR, Orange);
      ObjectSet ("DEV1", OBJPROP_WIDTH, 2);

int  MAPeriodM1=FindPeriod(1);
int  MAPeriodM5=FindPeriod(5);
int  MAPeriodM15=FindPeriod(15);
int  MAPeriodM30=FindPeriod(30);
int  MAPeriodM60=FindPeriod(60);
int  MAPeriodM240=FindPeriod(240);
 if (Period()==PERIOD_M1) MAPeriod=FindPeriod(1);
 if (Period()==PERIOD_M5) MAPeriod=FindPeriod(5);
 if (Period()==PERIOD_M15) MAPeriod=FindPeriod(15);
 if (Period()==PERIOD_M30) MAPeriod=FindPeriod(30);
 if (Period()==PERIOD_H1) MAPeriod=FindPeriod(60);
 if (Period()==PERIOD_H4) MAPeriod=FindPeriod(240);
        Show(10,240,MAPeriodM240);
        Show(35,60,MAPeriodM60);
        Show(60,30,MAPeriodM30);
        Show(85,15,MAPeriodM15);
        Show(110,5,MAPeriodM5);
        Show(135,1,MAPeriodM1);
  //    MAPeriod=21;   
                  ObjectDelete("AlexHacker008");             
                  ObjectCreate("AlexHacker008", OBJ_LABEL, 0, 0, 0);
                  ObjectSetText("AlexHacker008","Ma = "+MAPeriod, 15, "Arial", Orange);
                  ObjectSet("AlexHacker008", OBJPROP_CORNER, 2);
                  ObjectSet("AlexHacker008", OBJPROP_XDISTANCE, 70);
                  ObjectSet("AlexHacker008", OBJPROP_YDISTANCE, 165);
                          
      IndicatorShortName( strMAType+ " (" +FindPeriod(Period()) + ") ");
   for(int i=300; i>=0; i--)
     {
      if (MAType==4)
        {
         MA_Cur=LSMA(MAPeriod,i);
         MA_Prev=LSMA(MAPeriod,i+1);
        }
      else
        {
         MA_Cur=iMA(NULL,0,MAPeriod,0,MAMode,PRICE_CLOSE,i);
         MA_Prev=iMA(NULL,0,MAPeriod,0,MAMode,PRICE_CLOSE,i+1);
        }
//---- COLOR CODING
      ExtMapBuffer3[i]=MA_Cur; //red 
      ExtMapBuffer2[i]=MA_Cur; //green
      ExtMapBuffer1[i]=MA_Cur; //yellow

//----
      if (MA_Prev > MA_Cur)
        {
         ExtMapBuffer2[i]=EMPTY_VALUE;

        }
      else if (MA_Prev < MA_Cur)
           {
            ExtMapBuffer1[i]=EMPTY_VALUE; //-1 red/greem tight
           }
         else
           {
            ExtMapBuffer1[i]=EMPTY_VALUE;//EMPTY_VALUE;
            ExtMapBuffer2[i]=EMPTY_VALUE;//EMPTY_VALUE;
            ////Show(" = ",10,Red,15,25);
            //Show(" = ",35,Red,15,25);
            
           }
     }
   return(0);
  }
//+------------------------------------------------------------------+
void Show(int xx, int period, int MA_periods)
   { ObjectDelete("AlexHacker111"+DoubleToStr(xx,0));
   ObjectCreate("AlexHacker111"+DoubleToStr(xx,0), OBJ_LABEL, 0, 0, 0);
   double will_0=iWPR(NULL,period,34,0);
         string will;
         double MA_Cur1=iCustom(NULL,period,"MA_in_Color",MA_periods,4,0,0);
         double MA_Prev1=iCustom(NULL,period,"MA_in_Color",MA_periods,4,0,0+1);
          if (MA_Prev1 > MA_Cur1)
        {
         will=MA_periods+"   "+DoubleToStr(period,0);
       color   Cor= Orange;
        }
      else if (MA_Prev1 < MA_Cur1)
           {
            will=MA_periods+"   "+DoubleToStr(period,0); //-1 red/greem tight
            Cor= DeepSkyBlue;
           }
   if (will_0==0) 
      {ObjectSetText("AlexHacker111"+DoubleToStr(xx,0),will+" : "+"", 25, "Arial",Red);}
   else if (will_0==-100)
         {
         ObjectSetText("AlexHacker111"+DoubleToStr(xx,0),will+" : "+"", 25, "Arial",Red);
         }
   else 
         {ObjectSetText("AlexHacker111"+DoubleToStr(xx,0),will+" : "+DoubleToStr(will_0,2), 15, "Arial",Cor);}
         
   ObjectSet("AlexHacker111"+DoubleToStr(xx,0), OBJPROP_CORNER, 2);
   ObjectSet("AlexHacker111"+DoubleToStr(xx,0), OBJPROP_XDISTANCE, 70);
   ObjectSet("AlexHacker111"+DoubleToStr(xx,0), OBJPROP_YDISTANCE, xx);
   return (0);
   }      
   
   int FindPeriod(int timeframe)     
    { int max=0; int min=0;
      int shift=12;
    double ZigZagMax, ZigZagMin;
    if (timeframe==PERIOD_M1) shift=34; 
      for (int i = 0; i<=300;i++)
       {  
             ZigZagMax=NormalizeDouble(iCustom(NULL, timeframe, "ZigZag", shift, 5, 3, 2, i),4);
            if (ZigZagMax!=0){ max=i;break;}   
       }
     
      for (int k = 0; k<=300;k++)
         {   
             ZigZagMin=NormalizeDouble(iCustom(NULL, timeframe, "ZigZag", shift, 5, 3, 1, k),4);
             
            if (ZigZagMin!=0) { min=k;break;}  
         }
      
         int MAPeriodss= MathAbs( max-min) ;
         
                  ObjectCreate("AlexHacker009", OBJ_LABEL, 0, 0, 0);
                  ObjectSetText("AlexHacker009","ZigZag = "+"min="+i+" max="+k, 15, "Arial", Orange);
                  ObjectSet("AlexHacker009", OBJPROP_CORNER, 2);
                  ObjectSet("AlexHacker009", OBJPROP_XDISTANCE, 70);
                  ObjectSet("AlexHacker009", OBJPROP_YDISTANCE, 190);
      return (MAPeriodss);
   }